from boodle.agent import *
import random

# Demons - a module for Andrew Plotkin's boodler
#
# (See http://www.eblong.com/zarf/boodler/index.html)

# Based on 'crows' by Andrew Plotkin and modified by Bob Igo.  This
# code file is in the public domain, with no warranty whatsoever.  All
# sounds Copyright 2001 by Bob Igo (bobigo@attbi.com), and are free
# for non-commercial use.

# This module consists of this file, which should be placed in your
# boodler effects path, and the sound files n[1-26].aiff, which should
# be placed in the boodler sound repository, under the directory
# voice/demons.

# python boodler.py demons.Phrases

# I have no idea if the phonemes ever sequence themselves in a way
# that means anything, but please let me know if they do.

demon_phonemes = [
	'voice/demons/n1.aiff',
	'voice/demons/n2.aiff',
	'voice/demons/n3.aiff',
	'voice/demons/n4.aiff',
	'voice/demons/n5.aiff',
	'voice/demons/n6.aiff',
	'voice/demons/n7.aiff',
	'voice/demons/n8.aiff',
	'voice/demons/n9.aiff',
	'voice/demons/n10.aiff',
	'voice/demons/n11.aiff',
	'voice/demons/n12.aiff',
	'voice/demons/n13.aiff',
	'voice/demons/n14.aiff',
	'voice/demons/n15.aiff',
	'voice/demons/n16.aiff',
	'voice/demons/n17.aiff',
	'voice/demons/n18.aiff',
	'voice/demons/n19.aiff',
	'voice/demons/n20.aiff',
	'voice/demons/n21.aiff',
	'voice/demons/n22.aiff',
	'voice/demons/n23.aiff',
	'voice/demons/n24.aiff',
	'voice/demons/n25.aiff',
	'voice/demons/n26.aiff'
]

class Phrase(Agent):
	name = 'play a demon phrase'
	def __init__(self, pitch=1.0):
		Agent.__init__(self)
		self.pitch = float(pitch)
		self.pan = random.uniform(-1, 1)
		self.vol = random.uniform(0.5, 1)		
	def run(self):
		num_phonemes = random.randint(8, 17)
		time = 0.0
		prev = ''
		for ix in range(num_phonemes):
			phoneme = random.choice(demon_phonemes)
			if (phoneme == prev):
				phoneme = random.choice(demon_phonemes)
			prev = phoneme
			interval = self.sched_note_pan(phoneme, self.pan, self.pitch, self.vol, time)
			time = time + interval - 0.025
		self.resched(time + random.uniform(0.75, 3.5))

class BigDemons(Agent):
	name = 'big heavy demons talking'
	def __init__(self):
		Agent.__init__(self)
	def run(self):
		pitch = random.uniform(0.7, 1.0)
		ag = Phrase(pitch)
		self.sched_agent(ag)

class TinyDemons(Agent):
	name = 'very small demons talking'
	def __init__(self):
		Agent.__init__(self)
	def run(self):
		pitch = random.uniform(1.5, 2.0)
		ag = Phrase(pitch)
		self.sched_agent(ag)

class Phrases(Agent):
	name = 'pit of demons'
	def run(self):
		chan = self.new_channel(1.0)
		ag = FadeInOutAgent(TinyDemons(), 1, 6)
		self.sched_agent(ag, 0.0, chan)
		ag = FadeInOutAgent(BigDemons(), 6, 1)
		self.sched_agent(ag, 1.0, chan)
		chan2 = self.new_channel(0.3)
		ag = FadeInOutAgent(TinyDemons(), 6, 1)
		self.sched_agent(ag, 2.0, chan2)
		ag = FadeInOutAgent(BigDemons(), 1, 6)
		self.sched_agent(ag, 3.0, chan2)
		self.resched(random.uniform(5.0, 10.0))
