from boodle.agent import *
import random

# Secrets - a module for Andrew Plotkin's boodler
#
# (See http://www.eblong.com/zarf/boodler/index.html)
#
# Created by Paul Mazaitis.  This code file is in the public domain,
# with no warranty whatsoever.  All sounds Copyright 2001 by Paul
# Mazaitis, and are free for non-commercial use.
#
# This module consists of this file, which should be placed in your
# boodler effects path, and the sound files c[1-13].aiff, which should
# be placed in the boodler sound repository, under the directory
# voice/secrets.
#
# None of the secret phrases mean anything.  More accurately: they have
# not been vetted in every language.


secrets = [
	'voice/secrets/c1.aiff',
	'voice/secrets/c2.aiff',
	'voice/secrets/c3.aiff',
	'voice/secrets/c4.aiff',
	'voice/secrets/c5.aiff',
	'voice/secrets/c6.aiff',
	'voice/secrets/c7.aiff',
	'voice/secrets/c8.aiff',
	'voice/secrets/c9.aiff',
	'voice/secrets/c10.aiff',
	'voice/secrets/c11.aiff',
	'voice/secrets/c12.aiff',
	'voice/secrets/c13.aiff'
]

class One(Agent):
	name = 'play a random secret'
	def __init__(self, pitch=1.0):
		Agent.__init__(self)
		self.pitch = float(pitch)
		self.pan = random.uniform(-1, 1)
		self.vol = random.uniform(0.3, 1)
	def run(self):
		secret = random.choice(secrets)
		dur = self.sched_note_pan(secret, self.pan, self.pitch, self.vol)
		self.resched(dur)

class Many(Agent):
	name = 'chamber of secrets'
	def run(self):
		pitch = random.uniform(0.8, 1.1)
		self.sched_agent(FadeInOutAgent(One(pitch), 1, 6))
		delay = random.uniform(2, 4)
		self.resched(delay)
